#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <inttypes.h>

#include "rdtsc.h"

/* 32KB covers my L1 */
#define POOL (32 * 1024)
char pool[POOL];

#define WARM 10000

int main(int argc, char *argv[])
{
    unsigned int nprobe = atoi(argv[1]) + WARM;

    uint64_t *probe = (uint64_t *) malloc(sizeof(uint64_t) * nprobe);
    for (int i = 0; i < nprobe; i ++) {
        register int sum = 0;

        // fill cacheline
        for (register int j = 0; j < POOL;  j ++) {
            sum += pool[j] + 1;
        }

        uint64_t beg, end;

        beg = rdtsc_beg();

#define STEP 1024
        for (register int s = 0; s < STEP; s ++) {
            for (register int j = 0; j < POOL;  j += STEP) {
                sum += pool[j] + 1;
            }
        }

        end = rdtsc_end();

        probe[i] = end - beg;
    }

    for (int i = WARM; i < nprobe; i ++) {
        printf("%" PRIu64 "\n", probe[i]);
    }
}
